<?php
/* Copyright (C) 2003      Rodolphe Quiedeville <rodolphe@quiedeville.org>
 * Copyright (C) 2004-2005 Laurent Destailleur  <eldy@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * $Id: fiche.php,v 1.11 2005/01/23 02:03:08 eldy Exp $
 * $Source: /cvsroot/dolibarr/dolibarr/htdocs/compta/tva/fiche.php,v $
 *
 */

/**	    \file       htdocs/compta/tva/fiche.php
		\brief      Page des rglements de TVA
		\version    $Revision: 1.11 $
*/

/*
 * Modification de la table tva pour ajouter un lien vers l'criture bancaire
 * ALTER TABLE `llx_tva` ADD `fk_bank` INT( 11 ) NOT NULL ;
 */

require("./pre.inc.php");
require("../../tva.class.php");


$mesg = '';

if ($_POST["action"] == 'add' && $_POST["cancel"] <> $langs->trans("Cancel"))
{
    if ($_POST["paiementid"] > 0)
    {
        $paiementid = $_POST['paiementid'];
		$datepaye = mktime(12,0,0, $_POST['datepmonth'], $_POST['datepday'], $_POST['datepyear']);
		$datevaleur = mktime(12,0,0, $_POST['datevmonth'], $_POST['datevday'], $_POST['datevyear']);
		$montant = $_POST['amount'];
		$num_paiement = empty($_POST['num_paiement']) ? '' : $_POST['num_paiement'];

        $db->begin();
		// Insertion dans llx_bank
		$label = 'Rglement TVA';
		$acc = new Account($db, $_POST['accountid']);
		// Dommage, il manque un paramtre pour mettre directement la date de valeur
		$bank_line_id = 
			$acc->addline(
				$_POST['datepyear'].'-'.$_POST['datepmonth'].'-'.$_POST['datepday'],
					// Il doit bien exister une fonction pour transformer les dates mais j'avoue que je n'ai pas cherch...
				$paiementid, $label, -$montant, $num_paiement, '', $user);
		if ($bank_line_id <= 0)
		{
            // Il y a eu erreur
            $db->rollback();
            $fiche_erreur_message = $langs->trans("ErrorUnknown");
		}
		else
		{
			$acc->datev_update($bank_line_id, $_POST['datevyear'].'-'.$_POST['datevmonth'].'-'.$_POST['datevday']);
			$db->commit();
			$tva = new Tva($db);
			$tva->add_payement(
				$datevaleur,
				$datepaye,
				$montant,
				$bank_line_id
				);
			Header ( "Location: reglement.php");
        }
    }
    else
    {
        $fiche_erreur_message = '<div class="error">Vous devez slectionner un mode de paiement</div>';
    }
}

llxHeader();

/*
 *
 *
 */
$html = new Form($db);
if ($_GET["action"] == 'create')
{
  print "<form action=\"fiche.php\" method=\"post\">\n";
  print '<input type="hidden" name="action" value="add">';

  print '<div class="titre">Nouveau rglement TVA</div><br>';
      
  print '<table class="border" width="100%">';
  print "<tr>";
  print '<td>'.$langs->trans("DatePayment").'</td><td>';
  print $html->select_date("","datev");
  print '</td></tr>';
  print '<td>'.$langs->trans("DateValue").'</td><td>';
  print $html->select_date("","datep");
  print '</td></tr>';
  print '<tr><td>'.$langs->trans("Amount").'</td><td><input name="amount" size="10" value=""></td></tr>';
  
	print '<tr><td>'.$langs->trans("Type").' :</td><td><select name="paiementid">';

	$sql = "SELECT id, libelle FROM ".MAIN_DB_PREFIX."c_paiement ORDER BY id";
	$result = $db->query($sql);
	if ($result)
	{
		$num = $db->num_rows($result);
		$i = 0; 
		while ($i < $num)
		{
			$objopt = $db->fetch_object($result);
			print "<option value=\"$objopt->id\">$objopt->libelle</option>\n";
			$i++;
		}
	}
	print "</select>";
	print "</td>\n";
	print '</tr>';
	print "<tr><td>Numro :</td><td><input name=\"num_paiement\" type=\"text\"><br><em>Numro du chque / virement</em></td></tr>\n";

	print "<tr><td>Compte  dbiter :</td><td><select name=\"accountid\">\n";
	$sql = "SELECT rowid, label FROM ".MAIN_DB_PREFIX."bank_account ORDER BY rowid";
	$result = $db->query($sql);
	if ($result)
	{
		$num = $db->num_rows();
		$i = 0; 
		while ($i < $num)
		{
			$objopt = $db->fetch_object($result);
			print '<option value="'.$objopt->rowid.'"';
			if (defined("FACTURE_RIB_NUMBER") && FACTURE_RIB_NUMBER == $objopt->rowid)
			{
				print ' selected';
			}
			print '>'.$objopt->label.'</option>';
			$i++;
		}
	}
	print "</select>";
	print "</td></tr>\n";

  
  print '<tr><td>&nbsp;</td><td><input type="submit" value="'.$langs->trans("Save").'">&nbsp;';
  print '<input type="submit" name="cancel" value="'.$langs->trans("Cancel").'"></td></tr>';
  print '</table>';
  print '</form>';      
}


/* ************************************************************************** */
/*                                                                            */ 
/* Barre d'action                                                             */ 
/*                                                                            */ 
/* ************************************************************************** */

// Aucune action



$db->close();

llxFooter("<em>Derni&egrave;re modification $Date: 2005/01/23 02:03:08 $ r&eacute;vision $Revision: 1.11 $</em>");
?>
